apiVersion: apps/v1
kind: Deployment
metadata:
  name: nginx
spec:
  replicas: 3
  selector:
    matchLabels:
      run: nginx
  strategy:                    # <-- Type of upgrade
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 1              # <-- number of extra Pods
      maxUnavailable: 0        # <-- respective number of unavailable Pods
  template:
    metadata:
      labels:
        run: nginx
    spec:
      containers:
      - image: nginx:1.17       # <-- new version 
        name: nginx
